#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n, q, t, k, x;
    cin>>n;
    vector<int> a(n), b(32,0);
    for(int i=0; i<n; i++){
        cin>>a[i];
    }
    for(int i=0; i<n; i++){
        for(int j=0; j<32; j++){
            if((1<<j)&a[i]) b[j]++;
        }
    }
    cin>>q;
    while(q--){
        cin>>t>>k;
        if(t==0){
            int s=0;
            for(int j=0; j<32; j++){
                if(k<=b[j]) s+=(1<<j);
            }
            cout<<s<<'\n';
        }
        else{
            cin>>x;
            for(int j=0; j<32; j++){
                b[j]=b[j]-((1<<j)&a[k-1])+((1<<j)&x);
            }
            a[k-1]=x;
        }
    }
    return 0;
}